## xmake.zip

=== core/src/sv/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7 FATAL_ERROR)
project(sv)

option(SHARED "Build as shared library" OFF)
option(COVERAGE "Turn on COVERAGE support" OFF)

if (COVERAGE AND NOT MSVC)
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} --coverage")
endif()

if(CMAKE_VERSION VERSION_LESS "3.1")
    if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
        set(CMAKE_C_FLAGS "-std=c99 ${CMAKE_C_FLAGS}")
    endif()
else()
    set(CMAKE_C_STANDARD 99)
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
if(MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W3")
else()
    if ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0 -g3 -DDEBUG")
    else()
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3")
    endif()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Werror -fomit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers -Wno-unused-parameter -Wno-unused-function")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-value -Wno-unused-result")
endif()

set(sv_INCLUDE_DIR ${CMAKE_CURRENT_LIST_DIR}/include)
set(sv_SOURCE_DIR  ${CMAKE_CURRENT_LIST_DIR}/src)
set(sv_TEST_DIR  ${CMAKE_CURRENT_LIST_DIR}/test)

file(GLOB sv_HEADERS ${sv_HEADERS} ${sv_INCLUDE_DIR}/*.h)
file(GLOB sv_SOURCES ${sv_SOURCES} ${sv_SOURCE_DIR}/*.c)

include_directories(${sv_INCLUDE_DIR})
if(SHARED)
    if(MSVC)
        set(CMAKE_FLAGS
            CMAKE_CXX_FLAGS
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_C_FLAGS
            CMAKE_C_FLAGS_DEBUG
            CMAKE_C_FLAGS_RELEASE
        )
        foreach(CMAKE_FLAG ${CMAKE_FLAGS})
            string(REPLACE "/MD" "/MT" ${CMAKE_FLAG} "${${CMAKE_FLAG}}")
            string(REPLACE "/MDd" "/MTd" ${CMAKE_FLAG} "${${CMAKE_FLAG}}")
        endforeach()
    endif()

    add_library(${PROJECT_NAME} SHARED ${sv_SOURCES} ${sv_HEADERS})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DSV_BUILD_DYNAMIC_LINK=1")
else()
    add_library(${PROJECT_NAME} STATIC ${sv_SOURCES} ${sv_HEADERS})
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DSV_COMPILE=1")

enable_testing()
add_subdirectory(${sv_TEST_DIR})

if(WIN32)
    set(CPACK_GENERATOR "WIX")
    set(CPACK_SOURCE_GENERATOR "ZIP")
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CPACK_GENERATOR "PackageMake")
else()
    set(CPACK_GENERATOR "DEB;RPM")
    set(CPACK_SOURCE_GENERATOR "TGZ")
endif()

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Lucas Abel")

set(CPACK_PACKAGE_VERSION "1.0.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")
set(CPACK_PACKAGE_VERSION_PATCH "0")

set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/UNLICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README.md")

set(CPACK_SOURCE_IGNORE_FILES "${CMAKE_SOURCE_DIR}/build/;${CMAKE_SOURCE_DIR}/.git/")

set(CPACK_SYSTEM_NAME "")

include(CPack)

=== scripts/debian/changelog ===
xmake (2.1.5-1) yakkety; urgency=medium

  * update 2.1.5

 -- ruki <waruqi@gmail.com>  Thu, 05 Aug 2017 21:22:12 +0800

xmake (2.1.4-1) yakkety; urgency=medium

  * update 2.1.4

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-13) yakkety; urgency=medium

  * add uninstall

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-12) yakkety; urgency=medium

  * fix bin dir

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-11) yakkety; urgency=medium

  * modify install path

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-10) yakkety; urgency=medium

  * modify install script

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-9) yakkety; urgency=medium

  * remove test xmake

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-8) yakkety; urgency=medium

  * fix binary dir for install debian

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-7) yakkety; urgency=medium

  * modify install dir

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-6) yakkety; urgency=medium

  * remove sudo for install

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-5) yakkety; urgency=medium

  * modify permission problem

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-4) yakkety; urgency=medium

  * modify package ppa script

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-3) yakkety; urgency=medium

  * modify ppa install path

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-2) yakkety; urgency=medium

  * modify debian script

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

xmake (2.1.3-1) yakkety; urgency=medium

  * initial release

 -- ruki <waruqi@gmail.com>  Thu, 06 Apr 2017 21:22:12 +0800

=== scripts/PKGBUILD ===
# Maintainer: <waruqi@gmail.com>
# PKGBuild Create By: lumpyzhu <lumpy.zhu@gmail.com>

pkgname=xmake
pkgver=2.1.7
pkgrel=1
pkgdesc="A make-like build utility based on Lua"
arch=('i686' 'x86_64')
url="https://github.com/tboox/xmake"
license=('Apache')
makedepends=()
source=("$pkgname.zip::https://github.com/tboox/xmake/archive/v${pkgver}.zip")
sha256sums=('c25436672668df3f8db6615fb97b7cd94c47fa9267a774265897ae318837c41f')

build() {
    cd "$srcdir/${pkgname}-${pkgver}"
    make build
}

package() {
    cd "$srcdir/${pkgname}-${pkgver}"
    mkdir -p "${pkgdir}/usr/share"
    cp -r "./xmake" "${pkgdir}/usr/share/"
    install -Dm755 ./core/src/demo/demo.b "${pkgdir}/usr/share/xmake/xmake"
    echo "#/!bin/bash
export XMAKE_PROGRAM_DIR=/usr/share/xmake
/usr/share/xmake/xmake \"\$@\"
" > ./xmake.sh
    install -Dm755 "./xmake.sh" "${pkgdir}/usr/bin/xmake"
}

=== scripts/debian/control ===
Source: xmake
Section: contrib/devel
Priority: optional
Maintainer: ruki <waruqi@gmail.com>
Build-Depends: debhelper (>=9)
Standards-Version: 3.9.7
Homepage: http://xmake.io
#Vcs-Git: git@github.com:tboox/xmake.git
#Vcs-Browser: https://github.com/tboox/xmake.git

Package: xmake
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A make-like build utility based on Lua
 xmake focuses on making development and building easier and
 provides many features (.e.g package, install, plugin, macro, 
 action, option, task ...), so that any developer can quickly 
 pick it up and enjoy the productivity boost when developing 
 and building project.

=== scripts/debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# prefix
prefix=$(CURDIR)/debian/xmake/usr

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	make build
	touch $@
clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	mkdir -p $(prefix)/bin
	mkdir -p $(prefix)/share
	cp -r $(CURDIR)/xmake $(prefix)/share
	cp $(CURDIR)/core/src/demo/demo.b $(prefix)/share/xmake/xmake 
	echo '#!/bin/bash' > $(prefix)/bin/xmake
	echo 'export XMAKE_PROGRAM_DIR=/usr/share/xmake' >> $(prefix)/bin/xmake
	echo '/usr/share/xmake/xmake "$$@"' >> $(prefix)/bin/xmake
	chmod 755 $(prefix)/bin/xmake

distclean: clean

uninstall:
	if [ -f /usr/bin/xmake ]; then rm /usr/bin/xmake; fi
	if [ -d /usr/share/xmake ]; then rm -rf /usr/share/xmake; fi

binary-indep: build install
# We have nothing to do by default.
# # Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs $(CURDIR)/CHANGELOG.md
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install uninstall configure
